﻿
var KeyHandler = {
	tvKey			: null,
	MainMenuAnchor		: null,
	LoadingPlayerAnchor	: null,
	LivePlayerAnchor	: null,
	VODPlayerAnchor		: null,
	Selectbox		: null,
	NumberEntered		: '',
	ChSelectorTimeout	: null,
	Menu			: 0,
	info_focus		: false,
	black_line		: false,
	k			: false,
	bl			: false,
};

KeyHandler.create = function() {

	this.MainMenuAnchor = document.getElementById('MainMenu_Anchor');
	this.LoadingPlayerAnchor = document.getElementById('LoadingPlayer_Anchor');
	this.LivePlayerAnchor = document.getElementById('LivePlayer_Anchor');
	this.VODPlayerAnchor = document.getElementById('VODPlayer_Anchor');
	this.SelectboxAnchor = document.getElementById('Selectbox_Anchor');
	this.tvKey = new Common.API.TVKeyValue();
};

KeyHandler.setFocus = function(menuID) {

	alert('KeyHandler.setFocus ' + menuID);
	switch (menuID) {
	case Main.MainMenu_ID:
		this.MainMenuAnchor.focus();
		break;
	case Main.LoadingPlayer_ID:
		this.LoadingPlayerAnchor.focus();
		break;
	case Main.LivePlayer_ID:
		this.LivePlayerAnchor.focus();
		break;
	case Main.VODPlayer_ID:
		this.VODPlayerAnchor.focus();
		break;
	case Main.Selectbox_ID:
		this.SelectboxAnchor.focus();
		break;
	default:
		alert('Unhandled key');
		break;
	}
};

KeyHandler.KanalSelector = function() {
	var max = API.chan_counter;

	if (KeyHandler.NumberEntered > max)
		Display.status('ошибка ввода');
	else if (KeyHandler.NumberEntered > 0) {
		if (KeyHandler.NumberEntered < 11)
			Main.selected_channel = (KeyHandler.NumberEntered - 1);
		else if((KeyHandler.NumberEntered % 10) > 0)
			Main.selected_channel = ((KeyHandler.NumberEntered % 10) - 1);
		else
			Main.selected_channel = 9;
		if (Main.selected_channel < 4)
			Main.selected_page = Math.round(KeyHandler.NumberEntered / 10);
		else
			Main.selected_page = Math.round((KeyHandler.NumberEntered / 10) - 1);
		Main.chan_array_index = (parseInt(KeyHandler.NumberEntered) - 1);
		Main.PlayChannel();
	}
	KeyHandler.NumberEntered = '';
};

KeyHandler.Keys10 = function(keyCode) {
	var number = '';

	switch (keyCode) {
	case this.tvKey.KEY_1:
		number = '1';
		break;
	case this.tvKey.KEY_2:
		number = '2';
		break;
	case this.tvKey.KEY_3:
		number = '3';
		break;
	case this.tvKey.KEY_4:
		number = '4';
		break;
	case this.tvKey.KEY_5:
		number = '5';
		break;
	case this.tvKey.KEY_6:
		number = '6';
		break;
	case this.tvKey.KEY_7:
		number = '7';
		break;
	case this.tvKey.KEY_8:
		number = '8';
		break;
	case this.tvKey.KEY_9:
		number = '9';
		break;
	case this.tvKey.KEY_0:
		number = '0';
		break;
	default:
		alert('KeyHandler.Keys10: Unhandled key');
		break;
	}
	KeyHandler.NumberEntered = KeyHandler.NumberEntered + number;
	if (number != '' && KeyHandler.NumberEntered != '') {
		Display.status1(KeyHandler.NumberEntered);
		clearTimeout(this.ChSelectorTimeout);
		this.ChSelectorTimeout = setTimeout('KeyHandler.KanalSelector()', 2000);
	}
};


KeyHandler.MainMenuKeyDown = function() {
	var keyCode0 = event.keyCode;

	KeyHandler.Keys10(keyCode0);

	switch (keyCode0) {
	case this.tvKey.KEY_INFO:
		break;
	case this.tvKey.KEY_TOOLS:
		Player.stopVideo();
		Setup.setFormular();
		break;
	case this.tvKey.KEY_MENU:
		widgetAPI.blockNavigation(event);
		this.Menu = ((this.Menu == 0) ? 1 : 0);
		pluginAPI.ShowTools(this.Menu);
		break;
	case 259://PRE-CH EMU
		Main.PlayPrevChannel();
		break;
	case this.tvKey.KEY_EXIT:
		widgetAPI.blockNavigation(event);
		if (Player.state == Player.STATE_STOPPED)
			widgetAPI.sendReturnEvent();
		else
			Player.ReturnMenu();
		break;
	case this.tvKey.KEY_RETURN:
		widgetAPI.blockNavigation(event);
		if (Player.state == Player.STATE_STOPPED) {
			Main.DEL = true;
			Main.PlayPrevPlaylist();
		} else if (Player.state == Player.STATE_PLAYING || Player.total_time != 0 ) {
			if (Player.mode == Player.MODE_STREAMING)
				KeyHandler.setFocus(Main.LivePlayer_ID);
			else
				KeyHandler.setFocus(Main.VODPlayer_ID);
			Main.SetSelectedPosition();
			Main.unregistTVKey();
			Display.showplayer();
			Display.hidemenu();
		} else {
			Player.ReturnMenu();
		}
		break;
	case this.tvKey.KEY_DOWN:
		Main.selectNextChannel();
		break;
	case this.tvKey.KEY_UP:
		Main.selectPrevChannel();
		break;
	case this.tvKey.KEY_LEFT:
		Main.selectPrevPage();
		break;
	case this.tvKey.KEY_RIGHT:
		Main.selectNextPage();
		break;
	case this.tvKey.KEY_ENTER:
		Main.PlayChannel();
		break;
	case this.tvKey.KEY_RED:
		Main.showCategorySelector();
		break;
	case tvKey.KEY_BLUE:
		//Main.Menu();
		if (Player.state == Player.STATE_STOPPED && API.XML_URL.indexOf('XML') > -1) {
			Main.star = true;
			Main.playlist();
		} else if (Player.state == Player.STATE_STOPPED && Main.nuber_step > 1 && Main.ret) {
			this.bl = true;
			Main.PlayPrevPlaylist();
		} else if (Player.state == Player.STATE_STOPPED)
			Main.PlayPrevPlaylist();
		break;
	case this.tvKey.KEY_FF:
		widgetAPI.blockNavigation(event);
		if (Main.url_next_page != '') {
			Main.pl_url = Main.url_next_page;
			this.k = true;
			Main.nuber_p ++;
			Main.nuber_step ++;
			Main.playlist();
		} else if (API.prev_page_url != '') {
			Main.pl_url = API.prev_page_url;
			Main.nuber_p ++;
			Main.nuber_step ++;
			Main.playlist();
		} else
			Display.status('Недоступно!');
		break;
	case tvKey.KEY_PAUSE:
		widgetAPI.blockNavigation(event);
		break;
	case this.tvKey.KEY_RW:
		widgetAPI.blockNavigation(event);
		if (Main.url_prev_page != '') {
			Main.pl_url = Main.url_prev_page;
			this.k = true;
			Main.nuber_p = Main.nuber_p - 1;
			Main.nuber_step ++;
			Main.playlist();
		} else if (API.next_page_url != '') {
			Main.pl_url = API.next_page_url;
			Main.nuber_p --;
			Main.nuber_step ++;
			Main.playlist();
		} else
			Display.status('Недоступно!');
		break;
	case this.tvKey.KEY_VOL_UP:
		break;
	case this.tvKey.KEY_VOL_DOWN:
		break;
	case this.tvKey.KEY_MUTE:
		break;
	case 65://KEY_CH_DOWN
		Main.scrolling = Main.scrolling + 28;
		var test = document.getElementsByTagName('table')[0];
		test.style.margin = Main.scrolling + 'px 0px 0px 0px ';
		break;
	case 68://KEY_CH_UP 
		Main.scrolling = Main.scrolling - 28;
		var test = document.getElementsByTagName('table')[0];
		test.style.margin = Main.scrolling + 'px 0px 0px 0px ';
		break;
	case this.tvKey.KEY_PLAY:
		widgetAPI.blockNavigation(event);
		if (Player.state == Player.STATE_PAUSE)
			Player.resumeVideo();
		else if (Player.state == Player.STATE_STOPPED) {
			Main.PlayChannel();
			Player.next = true;
		} else if (Player.total_time != 0) {
			if (Player.next == false && Player.repeat == false) {
				Player.next = true;
				Display.status('Последовательное воспроизведение');
			} else if (Player.next == true && Player.repeat == false) {
				Player.repeat = true;
				Display.status('Повторное воспроизведение');
			} else if (Player.next == true && Player.repeat == true) {
				Player.next = false;
				Player.repeat = false;
				Display.status('Всё ОТКЛЮЧЕННО !');
			}
		}
		break;
	case 192://rec 
		widgetAPI.blockNavigation(event);
		Display.status('Widget version: ' + Main.ver + ', TV MAC: ' + Main.MAC, 0);
		break;
	case tvKey.KEY_SUBTITLE:
		Player.SEFSetNextAudioStream();
		break;
	default:
		alert('KeyHandler.MainMenuKeyDown: Unhandled key');
		break;
	}
};

KeyHandler.LoadingPlayerKeyDown = function() {
	var keyCode1 = event.keyCode;

	switch (keyCode1) {
	case this.tvKey.KEY_EXIT:
	case this.tvKey.KEY_RETURN:
	case this.tvKey.KEY_STOP:
		if (Main.loading_pl == false) {
			widgetAPI.blockNavigation(event);
			Player.ReturnMenu();
		}
		break;
	default:
		alert('Unhandled key');
		break;
	}
};


KeyHandler.SelectboxKeyDown = function() {
	var keyCode4 = event.keyCode;

	switch (keyCode4) {
	case this.tvKey.KEY_DOWN:
		Selectbox.selectNextItem();
		break;
	case this.tvKey.KEY_UP:
		Selectbox.selectPrevItem();
		break;
	case this.tvKey.KEY_ENTER:
		Selectbox.SelectCategory();
		break;
	case this.tvKey.KEY_LEFT:
		Selectbox.selectPrevPage();
		break;
	case this.tvKey.KEY_RIGHT:
		Selectbox.selectNextPage();
		break;
	case this.tvKey.KEY_EXIT:
	case this.tvKey.KEY_RETURN:
		widgetAPI.blockNavigation(event);
		Selectbox.selectbox_html.style.display = 'none';
		document.getElementById('rightHalf').style.display = 'block';
		KeyHandler.setFocus(Main.MainMenu_ID);
		break;
	default:
		alert('KeyHandler.SelectboxKeyDown: Unhandled key');
		break;
	}
};

KeyHandler.LivePlayerKeyDown = function() {
	var keyCode2 = event.keyCode;
	KeyHandler.Keys10(keyCode2);

	switch (keyCode2) {
	case this.tvKey.KEY_TOOLS:
		break;
	case this.tvKey.KEY_MENU:
		widgetAPI.blockNavigation(event);
		this.Menu = ((this.Menu == 0) ? 1 : 0);
		pluginAPI.ShowTools(this.Menu);
		break;
	case tvKey.KEY_GREEN:
		pluginAPI.ShowTools(0);
		break;
	case tvKey.KEY_YELLOW:
		pluginAPI.ShowTools(1);
		break;
	case tvKey.KEY_BLUE:
		if (Screen.getModeD2() >= 2)
			Screen.changeModeD2(0);
		else
			Screen.changeModeD2(Screen.getModeD2() + 1);
		break;
	case 259://PRE-CH EMU
		Main.PlayPrevChannel();
		break;
	case tvKey.KEY_UP:
	case 256://KEY_FAVCH EMU
	case 653://KEY_ASPECT
	case 1249://FULL SCREEN
	case 1086://BD DISC MENU
	//case 1249://FULL SCREEN  BD
		widgetAPI.blockNavigation(event);
		if (Player.getSize() >= 3 && Player.w > 0 &&
		    (Player.w > 720 || (Player.w / Player.h) > 1.34))
			Player.setSize(0, 1);
		else if (Player.getSize() >= 4)
			Player.setSize(0,1);
		else
			Player.setSize(Player.getSize() + 1, 1);
		break;
	case tvKey.KEY_DOWN:
		widgetAPI.blockNavigation(event);
		if (Player.getSize() == 0 && Player.w > 0 &&
		    (Player.w > 720 || (Player.w / Player.h) > 1.34))
			Player.setSize(3, 1);
		else if (Player.getSize() == 0)
			Player.setSize(4, 1);
		else
			Player.setSize(Player.getSize() - 1, 1);
		break;
	case 1219://KEY_3D
		Screen.changeMode();
		break;
	case this.tvKey.KEY_VOL_UP:
		break;
	case this.tvKey.KEY_VOL_DOWN:
		break;
	case this.tvKey.KEY_MUTE:
		break;
	case 65://KEY_CH_DOWN
		Main.selectPrevChannel();
		Main.PlayChannel();
		break;
	case 68://KEY_CH_UP
		Main.selectNextChannel();
		Main.PlayChannel();
		break;
	case this.tvKey.KEY_INFO:
	case this.tvKey.KEY_ENTER:
		Display.status1(API.channels[Main.chan_array_index][0]);
		Display.showplayer();
		break;
	case this.tvKey.KEY_EXIT:
		widgetAPI.blockNavigation(event);
		Player.ReturnMenu();
		break;
	case 1057: //KEY_12 TITLE MENU
	case this.tvKey.KEY_RETURN:
		widgetAPI.blockNavigation(event);
		Main.registTVKey();
		Display.hideplayer();
		Main.Menu();
		break;
	case tvKey.KEY_PLAY:
		Player.playVideo(Player.url);
		break;
	case tvKey.KEY_STOP:
		if (this.black_line) {
			document.getElementById('black_line_top').style.display = 'none';
			this.black_line = false;
		} else {
			document.getElementById('black_line_top').style.display = 'block';
			this.black_line = true;
		}
		break;
	case tvKey.KEY_SUBTITLE:
		Player.SEFSetNextAudioStream();
		break;
	default:
		alert('KeyHandler.LivePlayerKeyDown: Unhandled key');
		break;
	}
};

KeyHandler.VODPlayerKeyDown = function() {
	var keyCode3 = event.keyCode;

	switch (keyCode3) {
	case tvKey.KEY_0:
		Player.PercentJump(0);
		Display.status('0%');
		break;
	case tvKey.KEY_1:
		Player.PercentJump(1);
		break;
	case tvKey.KEY_2:
		Player.PercentJump(2);
		break;
	case tvKey.KEY_3:
		Player.PercentJump(3);
		break;
	case tvKey.KEY_4:
		Player.PercentJump(4);
		break;
	case tvKey.KEY_5:
		Player.PercentJump(5);
		break;
	case tvKey.KEY_6:
		Player.PercentJump(6);
		break;
	case tvKey.KEY_7:
		Player.PercentJump(7);
		break;
	case tvKey.KEY_8:
		Player.PercentJump(8);
		break;
	case tvKey.KEY_9:
		Player.PercentJump(9);
		break;
	case this.tvKey.KEY_VOL_UP:
		break;
	case this.tvKey.KEY_VOL_DOWN:
		break;
	case this.tvKey.KEY_MUTE:
		break;
	case 259://PRE-CH EMU
		Main.PlayPrevChannel();
		break;
	case 68://KEY_CH_UP
		Main.selectNextChannel();
		Main.PlayChannel();
		break;
	case 65://KEY_CH_DOWN
		Main.selectPrevChannel();
		Main.PlayChannel();
		break;
	case this.tvKey.KEY_TOOLS:
		break;
	case this.tvKey.KEY_INFO:
		Display.status1(API.channels[Main.chan_array_index][0]);
		Display.showplayer();
		break;
	case this.tvKey.KEY_MENU:
		widgetAPI.blockNavigation(event);
		this.Menu = ((this.Menu == 0) ? 1 : 0);
		pluginAPI.ShowTools(this.Menu);
		break;
	case tvKey.KEY_LEFT:
		Player.MinutesJump(-0.5);
		break;
	case tvKey.KEY_RIGHT:
		Player.MinutesJump(0.5);
		break;
	case tvKey.KEY_DOWN:
		Player.MinutesJump(-2);
		break;
	case tvKey.KEY_UP:
		Player.MinutesJump(2);
		break;
	case this.tvKey.KEY_ENTER:
		if (Player.state == Player.STATE_PAUSE)
			Player.resumeVideo();
		else
			Player.pauseVideo();
		break;
	case 1057: //KEY_12 TITLE MENU
	case this.tvKey.KEY_RETURN:
		widgetAPI.blockNavigation(event);
		Main.registTVKey();
		if (Player.total_time == 0)
			Player.stopVideo();
		Display.hideplayer();
		Main.Menu();
		break;
	case tvKey.KEY_STOP:
	case tvKey.KEY_EXIT:
		widgetAPI.blockNavigation(event); 
		Player.ReturnMenu();
		break;

	case tvKey.KEY_GREEN:
		pluginAPI.ShowTools(0);
		break;
	case tvKey.KEY_YELLOW:
		pluginAPI.ShowTools(1);
		break;
	case tvKey.KEY_BLUE:
		if (Screen.getModeD2() >= 2)
			Screen.changeModeD2(0);
		else
			Screen.changeModeD2(Screen.getModeD2() + 1);
		break;
	case 256://KEY_FAVCH EMU
	case 653://KEY_ASPECT
	case 1249://FULL SCREEN
	case 1086://BD DISC MENU
	//case 1249://FULL SCREEN  BD
		widgetAPI.blockNavigation(event);
		if (Player.getSize() >= 3 && Player.w > 0 &&
		    (Player.w > 720 || (Player.w / Player.h) > 1.34))
			Player.setSize(0, 1);
		else if (Player.getSize() >= 4)
			Player.setSize(0, 1);
		else
			Player.setSize(Player.getSize() + 1, 1);
		break;
	case 1219://KEY_3D
		Screen.changeMode();
		break;
	case tvKey.KEY_FF:
		Player.PlaySpeedChange(1);
		//Player.MinutesJump(1);
		break;
	case tvKey.KEY_RW:
		//Player.MinutesJump(-1);
		Player.PlaySpeedChange(-1);
		break;
	case tvKey.KEY_PAUSE:
		Player.pauseVideo();
		break;
	case tvKey.KEY_PLAY:
		Player.PlaySpeedChange(0);
		if (Player.state == Player.STATE_PAUSE)
			Player.resumeVideo();
		else if (Player.next == false && Player.repeat == false) {
			Player.next = true;
			Display.status('Последовательное воспроизведение');
		} else if (Player.next == true && Player.repeat == false) {
			Player.repeat = true;
			Display.status('Повторное воспроизведение');
		} else if (Player.next == true && Player.repeat == true) {
			Player.next = false;
			Player.repeat = false;
			Display.status('Всё ОТКЛЮЧЕННО !');
		}
		break;
	case tvKey.KEY_SUBTITLE:
		Player.SEFSetNextAudioStream();
		break;
	default:
		alert('KeyHandler.VODPlayerKeyDown: Unhandled key ' + keyCode3);
		break;
	}
};

