﻿var Screen = {
	plugin		:null,
	mode		:0,
	modeD2		:0,
};

Screen.init = function() {
	var success = true;

	this.plugin = document.getElementById('pluginScreen');
	if (!this.plugin)
		success = false;
	return success;
};

Screen.changeMode = function() {

	if (1 != pluginScreen.Flag3DEffectSupport())
		return;
	var m = pluginScreen.Get3DEffectMode();
	var k;
	for (var i = 0; i < 7; ++i) {
		k = (m + i + 1) % 8;
		if (1 == pluginScreen.Check3DEffectMode(k)) {
			pluginScreen.Set3DEffectMode(k);
			changeMode(mode);
			break;
		}
	}
};

Screen.getModeD2 = function() {
	try {
		if (1 == pluginScreen.Flag3DEffectSupport() ||
		    1 == pluginScreen.Flag3DTVConnect())
			return this.modeD2;
		else
			return 0;
	}catch(e) {
		return 0;
	}
};

Screen.changeModeD2 = function(mode) {

	this.modeD2 = mode;
	if (1 == pluginScreen.Flag3DEffectSupport() ||
	    1 == pluginScreen.Flag3DTVConnect()) {
		changeMode(mode);
		Player.playVideo(Main.url);
	}
};

changeMode = function(mode) {

	switch (mode) {
	case 0:
		Display.status('!3D OFF!');
		break;
	case 1:
		Display.status('!3D SIDE BY SIDE!');
		break;
	case 2:
		Display.status('!3D TOP BOTTOM!');
		break;
	}
	return mode;
};